using System;
using System.Collections.Generic;
using System.Text;

namespace Sudoku
{
    abstract public class Algorithm
    {
        protected SudokuTable t;

        protected string name = string.Empty;
        public string Name
        {
            get { return name; }
        }

        protected bool enabled = true;
        public bool Enabled
        {
            get { return enabled; }
            set { enabled = value; }
        }

        public abstract void solve(SudokuTable t);

        public abstract string TestCell(SudokuTable t, IntPair redCell, IntPair greenCell, int redCand, int greenCand);
    }
}
